MODULE secondaries
  ! This module contains all local secondary variables used in equations
  ! They can be defined as pointers, which saves some computing time,
  ! or they can be defined as normal arrays, which saves some debugging time...
  use dimensions,only:nz,species,ndim,idx

  integer,parameter::nsec=36+3*species+6*ndim
  double precision,dimension(nz,nsec),target::y


  double precision,pointer::bc1,bc2,bc3,bc4
  double precision,dimension(:),pointer::h,p,rho,T,lnp,grav,cP,ch,chid,surf,grada,delta,pm,st,sf,pt,pf
  double precision,dimension(:),pointer::Tst1,Tst2,mt,r,m,q,vmm,vpp,vtt,vrr,netheat,FNe,mue,ne
  double precision,dimension(:,:),pointer::xt1,xt2,vxx
  double precision,dimension(:,:),pointer::Ftot,sni,rni,pni,mui,na

!!$  double precision::bc1,bc2,bc3,bc4
!!$  double precision,dimension(nz)::h,p,rho,T,lnp,grav,cP,ch,chid,surf,grada,delta,pm,st,sf,pt,pf
!!$  double precision,dimension(nz)::Tst1,Tst2,mt,r,m,q,vmm,vpp,vtt,vrr,netheat,FNe,mue,ne
!!$  double precision,dimension(nz,species)::xt1,xt2,vxx
!!$  double precision,dimension(nz,ndim)::Ftot,sni,rni,pni,mui,na

contains
  subroutine pointers
    ! Target the pointers
    implicit none
    integer::i

    i=1
    bc1    =>y(1,i);i=i+1
    bc2    =>y(1,i);i=i+1
    bc3    =>y(1,i);i=i+1
    bc4    =>y(nz,i);i=i+1
    p=>y(:,i);i=i+1
    h=>y(:,i);i=i+1
    rho=>y(:,i);i=i+1
    T=>y(:,i);i=i+1
    lnp=>y(:,i);i=i+1
    grav=>y(:,i);i=i+1
    cP=>y(:,i);i=i+1
    st=>y(:,i);i=i+1
    sf=>y(:,i);i=i+1
    pt=>y(:,i);i=i+1
    pf=>y(:,i);i=i+1
    ch=>y(:,i);i=i+1
    chid=>y(:,i);i=i+1
    surf=>y(:,i);i=i+1
    grada=>y(:,i);i=i+1
    delta=>y(:,i);i=i+1
    pm=>y(:,i);i=i+1
    Tst1=>y(:,i);i=i+1
    Tst2=>y(:,i);i=i+1
    netheat=>y(:,i);i=i+1
    mt=>y(:,i);i=i+1
    r=>y(:,i);i=i+1
    m=>y(:,i);i=i+1 
    q=>y(:,i);i=i+1
    vmm=>y(:,i);i=i+1
    vtt=>y(:,i);i=i+1
    vrr=>y(:,i);i=i+1
    vpp=>y(:,i);i=i+1
    FNe=>y(:,i);i=i+1
    mue=>y(:,i);i=i+1
    ne =>y(:,i);i=i+1
    xt1=>y(:,i:i+species-1);i=i+species
    xt2=>y(:,i:i+species-1);i=i+species
    vxx=>y(:,i:i+species-1);i=i+species
    Ftot=>y(:,i:i+ndim-1);i=i+ndim
    sni=>y(:,i:i+ndim-1);i=i+ndim
    rni=>y(:,i:i+ndim-1);i=i+ndim
    mui=>y(:,i:i+ndim-1);i=i+ndim
    pni=>y(:,i:i+ndim-1);i=i+ndim
    na=>y(:,i:i+ndim-1);i=i+ndim
    if (i.ge.nsec+1) then
       print*,'provide more space for the target of pointers : nsec is',nsec
       print*,'But it needs to be greater than',i
       STOP
    endif
  end subroutine pointers
end MODULE secondaries
